#include "libgccvb.h"
#include "notes.h"
#include "voices.h"
#include "MUSPCS.H"

void PlayNote (u8 chan, u16 freq, u8 vol)
{ 
  // Set up the frequency the channel will play 
  SND_REGS[chan].SxFQH = freq >> 8; 
  SND_REGS[chan].SxFQL = freq & 0xFF; 

  // Set the volume for the channel (0-15, same for left/right) 
  SND_REGS[chan].SxLRV = (vol << 4) | vol; 

  // Envelope for the channel (makes the tone fade out) 
  SND_REGS[chan].SxEV0 = 0xF7; 
  SND_REGS[chan].SxEV1 = 0x01; 

  // Start the channel without interval 
  SND_REGS[chan].SxINT = 0x9F; 
}

int main ()
{
  u32 SongCycle = 0;
  unsigned int CurNote = 0;

  SND_REGS[WAVE1].SxRAM = 0;
  SND_REGS[WAVE1].SxLRV = 0x66;
  SND_REGS[WAVE1].SxINT = 0x80;

  SND_REGS[WAVE1].SxEV0 = 0xF7;
  SND_REGS[WAVE1].SxEV1 = 0x00;
  
  // Copy the sawtooth instrument to soundbank 1
  copymem((void*)WAVEDATA1, (void*)SAWTOOTH, 128);

  while(1)
  {
    /*
    for(SongCursor = 0; SongCursor <= SongLen; SongCursor++)
    {
      PlayNote(WAVE1, Song[SongCursor], 15);
      vbWaitFrame(10);
    }
    */

    if (SongCycle == 0x18000)
    {
      if(Song[CurNote] == ENDSONG) CurNote = 0;
      PlayNote(WAVE1, Song[CurNote], 15);
      CurNote++;
      SongCycle = 0;
    }
    else
    {
      SongCycle++; 
    }
  }
}